//================================================================================
// LeagueAS_Tweaks.
//================================================================================
class LeagueAS_Tweaks extends SpawnNotify
	Config(User);

var string Overlord;
var LeagueAS_HUD myHUD;
var config bool bNoSniperEnforcerFlashDynamicLights;
var config bool bNoShockBallDynamicLights;
var config bool bNoOtherProjectileDynamicLights;
var config bool bNoEffectsdynamicLights;
var config bool bNoLeveldynamicLights;
var config bool bNoFirstPersonMuzzleFlash;
var config bool bSimpleThirdPersonMuzzleFlash;
var config bool bNoMiniTracer;
var config bool bNoMiniShells;
var config bool bNoSniperEnforcerShells;
var config bool bSimpleItems;
var config bool bNoSpawnEffects;
var config bool bNoSparks;
var config bool bNoChips;
var config bool blilTweakSmokeReduction;
var config bool blilTweakGreenBlood;
var config bool bNoRocketsRot;
var config bool bNoShockBeamRot;
var config bool bSimpleCombo;
var config bool bSimpleShockBeam;
var config bool bInstaGibUseTeamColor;
var config int FreakyCombo;
var config int FreakyBeam;
var config int KillMsgType;
var config string EnforcerMsg;
var config string BioMsg;
var config string ShockMsg;
var config string PulseMsg;
var config string MiniMsg;
var config string RipperMsg;
var config string FlakMsg;
var config string RLMsg;
var config string SniperMsg;
var config string HammerMsg;
var config string WarHeadMsg;
var config string InstaMsg;
var config string TeleMsg;
var CSHPEntryActor EntryAct;

simulated event Actor SpawnNotification (Actor Actor)
{
	local int j;

	if ( Default.FreakyCombo > 0 )
	{
		switch (Actor.Class)
		{
			case Class'UT_ComboRing':
			if ( (Default.FreakyCombo < 4) || (Default.FreakyCombo == 7) || (Default.FreakyCombo == 8) )
			{
				Actor.Skin=Texture'TLThunder';
			} else {
				if ( (Default.FreakyCombo > 3) && (Default.FreakyCombo < 7) )
				{
					Actor.Skin=FireTexture'fireeffect50';
				} else {
					if ( Default.FreakyCombo == 9 )
					{
						Actor.Skin=ScriptedTexture'AmmoLed';
					}
				}
			}
			break;
			case Class'UT_RingExplosion':
			case Class'UT_RingExplosion3':
			case Class'UT_RingExplosion5':
			if ( (Default.FreakyCombo > 3) && (Default.FreakyCombo < 7) || (Default.FreakyCombo == 9) )
			{
				Actor.Skin=FireTexture'fireeffect50';
			}
			break;
			case Class'UT_RingExplosion4':
			if ( Default.FreakyCombo == 2 )
			{
				Actor.Skin=None;
			} else {
				if ( Default.FreakyCombo == 3 )
				{
					Actor.Skin=Texture'BlueBarInM';
				} else {
					if ( (Default.FreakyCombo > 3) && (Default.FreakyCombo < 7) )
					{
						Actor.Skin=FireTexture'fireeffect50';
					} else {
						if ( Default.FreakyCombo == 7 )
						{
							Actor.bHidden=True;
						} else {
							if ( Default.FreakyCombo == 9 )
							{
								Actor.Skin=Texture'Flakmuz';
							}
						}
					}
				}
			}
			break;
			case Class'ShockrifleWave':
			if ( (Default.FreakyCombo > 4) && (Default.FreakyCombo < 9) )
			{
				Actor.Mesh=None;
				Actor.Skin=None;
				Actor.Texture=Texture'MuzzleFlash2';
				Actor.DrawType=1;
				Actor.DrawScale=1.00;
			}
			if ( (Default.FreakyCombo > 6) && (Default.FreakyCombo < 9) )
			{
				Actor.Texture=Texture'Flakmuz';
			}
			if ( Default.FreakyCombo == 9 )
			{
				Actor.Mesh=Mesh'Moon1';
				Actor.MultiSkins[0]=FireTexture'UDamageFX';
				Actor.DrawScale=0.10;
			}
			break;
			case Class'ShockExplo':
			if ( Default.FreakyCombo > 4 )
			{
				Actor.bHidden=True;
			}
			break;
			case Class'ShockProj':
			if ( Default.FreakyCombo > 5 )
			{
				Actor.LightRadius=10;
				Actor.LightEffect=18;
				Actor.LightHue=42;
			}
			break;
			default:
		}
	}
	if ( Default.FreakyBeam > 0 )
	{
		switch (Actor.Class)
		{
			case Class'ShockBeam':
			if ( Default.FreakyBeam == 1 )
			{
				Actor.Mesh=LodMesh'RazorBlade';
			} else {
				if ( Default.FreakyBeam == 2 )
				{
					Actor.Mesh=LodMesh'PBolt';
					Actor.Texture=Texture'utflare5';
					Actor.DrawScale=0.20;
				} else {
					if ( Default.FreakyBeam == 3 )
					{
						Actor.LifeSpan=1.00;
					}
				}
			}
			break;
			case Class'supershockbeam':
			if ( Default.FreakyBeam == 1 )
			{
				Actor.Mesh=LodMesh'RazorBlade';
			} else {
				if ( Default.FreakyBeam == 2 )
				{
					Actor.Mesh=LodMesh'PBolt';
				} else {
					if ( Default.FreakyBeam == 3 )
					{
						Actor.LifeSpan=1.00;
					}
				}
			}
			break;
			default:
		}
	}
	if ( Actor.IsA('Effects') )
	{
		if ( Default.bNoEffectsdynamicLights )
		{
			Actor.LightEffect=15;
		}
		if ( Actor.IsA('UT_RingExplosion4') && Default.bSimpleCombo )
		{
			Actor.bHidden=True;
		}
		if ( Actor.IsA('ShockBeam') )
		{
			if ( Default.bSimpleShockBeam )
			{
				Actor.DrawScale=0.20;
			}
			if ( Default.bNoShockBeamRot )
			{
				Actor.RotationRate=rot(0,0,0);
			}
		}
		if ( Actor.IsA('UTSmokeTrail') && Default.blilTweakSmokeReduction )
		{
			Actor.ScaleGlow=0.30;
			Actor.LifeSpan=1.40;
			UTSmokeTrail(Actor).Curr=1;
			UTSmokeTrail(Actor).bRandomize=False;
		}
		if ( Actor.IsA('UT_Spark') && Default.bNoSparks )
		{
			Actor.bHidden=True;
		}
		if ( Actor.IsA('UT_Sparks') && Default.bNoSparks )
		{
			Actor.bHidden=True;
		}
		if ( Actor.IsA('Chip') && Default.bNoChips )
		{
			Actor.bHidden=True;
		}
		if ( Default.blilTweakGreenBlood && Actor.IsA('UT_Blood2') )
		{
			j=0;
JL0638:
			if ( j < 8 )
			{
				Effects(Actor).MultiSkins[j]=Texture'BloodSGrn';
				j++;
				goto JL0638;
			}
		}
	}
	if ( Default.blilTweakGreenBlood )
	{
		if ( Actor.IsA('UTBloodPool') )
		{
			j=0;
JL0691:
			if ( j < 5 )
			{
				UTBloodPool(Actor).Splats[j]=Texture'biosplat2';
				j++;
				goto JL0691;
			}
		}
		if ( Actor.IsA('BloodSplat') )
		{
			j=0;
JL06E1:
			if ( j < 10 )
			{
				BloodSplat(Actor).Texture=Texture'biosplat';
				Actor.DrawScale=0.65;
				j += 2;
				goto JL06E1;
			}
		}
		if ( Actor.IsA('UTCreatureChunks') )
		{
			j=self.Rand(4);
			if ( j < 2 )
			{
				if ( j == 0 )
				{
					Actor.Mesh=LodMesh'MercHead';
				} else {
					Actor.Mesh=LodMesh'MercPart';
				}
			} else {
				if ( j == 2 )
				{
					Actor.Mesh=LodMesh'MercGun';
				} else {
					Actor.Mesh=LodMesh'MercLeg';
				}
			}
			Actor.DrawScale=0.70;
		}
	}
	if ( Actor.IsA('Projectile') )
	{
		if (  !Actor.IsA('ShockProj') &&  !Actor.IsA('UT_ShellCase') && Default.bNoOtherProjectileDynamicLights )
		{
			Actor.LightEffect=15;
		}
		if ( Actor.IsA('ShockProj') && Default.bNoShockBallDynamicLights )
		{
			Actor.LightEffect=15;
		}
		if ( Actor.IsA('MiniShellCase') && Default.bNoMiniShells )
		{
			Actor.bHidden=True;
		}
		if (  !Actor.IsA('MiniShellCase') && Actor.IsA('UT_ShellCase') )
		{
			if ( Default.bNoSniperEnforcerFlashDynamicLights )
			{
				Actor.LightEffect=15;
			}
			if ( Default.bNoSniperEnforcerShells )
			{
				Actor.bHidden=True;
			}
		}
		if ( Actor.IsA('MTracer') && Default.bNoMiniTracer )
		{
			Actor.bHidden=True;
			Actor.LightType=0;
		}
		if ( Actor.IsA('RocketMk2') && Default.bNoRocketsRot )
		{
			Actor.RotationRate=rot(0,0,0);
		}
	}
	if ( Actor.IsA('minigun2') )
	{
		if ( Default.bSimpleThirdPersonMuzzleFlash )
		{
			Weapon(Actor).MuzzleFlashStyle=2;
			Weapon(Actor).MuzzleFlashTexture=Texture'Muzflsh';
			Weapon(Actor).MuzzleFlashScale=0.30;
		}
		if ( Default.bNoFirstPersonMuzzleFlash )
		{
			Weapon(Actor).bDrawMuzzleFlash=False;
		}
	}
	if ( Actor.IsA('EnhancedRespawn') && Default.bNoSpawnEffects )
	{
		Actor.bHidden=True;
	}
	if ( Actor.IsA('Pawn') && (Level.NetMode == 3) )
	{
		if ( (EntryAct != None) &&  !EntryAct.bDeleteMe )
		{
			EntryAct.AddPawn(Pawn(Actor));
		}
	}
	return Actor;
}

static function string getweaponstring (Class<Weapon> C)
{
	if ( True )
	{
		switch (C)
		{
			case Class'enforcer':
			case Class'doubleenforcer':
			return Default.EnforcerMsg;
			case Class'ut_biorifle':
			return Default.BioMsg;
			case Class'ShockRifle':
			return Default.ShockMsg;
			case Class'PulseGun':
			case Class'pulsegunTIW':
			return Default.PulseMsg;
			case Class'minigun2':
			case Class'Minigun2TIW':
			return Default.MiniMsg;
			case Class'ripper':
			return Default.RipperMsg;
			case Class'UT_FlakCannon':
			return Default.FlakMsg;
			case Class'UT_Eightball':
			return Default.RLMsg;
			case Class'SniperRifle':
			return Default.SniperMsg;
			case Class'ImpactHammer':
			return Default.HammerMsg;
			case Class'WarheadLauncher':
			return Default.WarHeadMsg;
			case Class'SuperShockRifle':
			case Class'TeamSuperShockRifle':
			return Default.InstaMsg;
			case Class'Translocator':
			return Default.TeleMsg;
			default:
		}
	}
}

defaultproperties
{
    bInstaGibUseTeamColor=True
    EnforcerMsg="%k riddled %o full of holes with the %w."
    BioMsg="%o drank a glass of %k's dripping green load."
    ShockMsg="%k inflicted mortal damage upon %o with the %w."
    PulseMsg="%o ate %k's burning plasma death."
    MiniMsg="%k's %w turned %o into a leaky piece of meat."
    RipperMsg="%k ripped a chunk of meat out of %o with the %w."
    FlakMsg="%o was ripped to shreds by %k's %w."
    RLMsg="%o was smacked down by %k's %w."
    SniperMsg="%k put a bullet through %o's head."
    HammerMsg="%o got smeared by %k's piston."
    WarHeadMsg="%o was vaporized by %k's %w!!"
    InstaMsg="%k electrified %o with the %w."
    TeleMsg="%k telefragged %o!"
}